<!DOCTYPE html>
<html>
    <head>
        <style>
            #chart {
                border: 1px solid black;
            }
        </style>
    </head>
    <body>
        <div class="container">
            <svg id="chart"></svg>
            <button onclick="changeData()">Change Data</button>
        </div>

        <script src="https://d3js.org/d3.v6.min.js"></script>
        <script>
            let data = [ // data to be fed to D3JS to generate bar chart
                {
                    name: "Yes",
                    value: 30
                },
                {
                    name: "No",
                    value: 20
                }
            ];

            const width = 700; // width & height of SVG element
            const height = 500;
            const margin = { // margin of the chart in the SVG DOM element
                top: 30,
                right: 40,
                bottom: 30,
                left: 40
            };

            const svg = d3.select("#chart") // select() = get DOM element based on selection (same as jQuery selection)
                .attr("viewBox", [0, 0, width, height]); // attr() = change attribute of DOM, viewBox = define the position & dimention of SVG

            plot();



            // other functions
            function changeData() { // function to demonstrate data modification
                data = [
                    {
                        name: "Yes",
                        value: 100
                    },
                    {
                        name: "No",
                        value: 300
                    }
                ];

                // another way to modify data
                // data[1].value += 10

                plot();
            }

            function plot() { // function to plot bar chart
                svg.selectAll('g').remove()

                const xScale = d3.scaleBand() /// scaleBand() = create scale for category based data (https://www.d3indepth.com/scales/)
                    .domain(d3.range(data.length)) // domain() = function that accepts a range as input (https://www.d3indepth.com/scales/)
                    .range([margin.left, width - margin.right]) // range() = function that produce a range as output (https://www.d3indepth.com/scales/)
                    .padding(0.1); // padding() = sets the padding between each bar (https://github.com/d3/d3-scale#band_padding)
                const yScale = d3.scaleLinear() // scaleLinear() = create scale function with linear values (y = x, output = input) (https://www.d3indepth.com/scales/)
                    .domain([0, d3.max(data, data => data.value)]).nice() // nice() = round values with either ceil() or floor() (https://stackoverflow.com/questions/34930763/what-is-the-logic-behind-d3-js-nice-ticks)
                    .range([height - margin.bottom, margin.top]);

                const xAxis = (g) => g
                    .attr("transform", `translate(0, ${height - margin.bottom})`)
                    .call( // call() = calls a function
                        d3.axisBottom(xScale) // axisBottom() = create bottom horizontal axis (https://www.tutorialsteacher.com/d3js/axes-in-d3)
                            .tickFormat(i => data[i].name) // tickFormat() = set custom format for axis tick (https://observablehq.com/@d3/axis-ticks)
                            .tickSizeOuter(0) // tickSizeOuter(0) = offset tick from axis position (https://www.geeksforgeeks.org/d3-js-axis-ticksizeouter-function)
                    )
                    .call((g) =>
                        g
                        .append('text') // append() = add new DOM element to selection & return the new element (https://bl.ocks.org/uicoded/dec8786d89184c88fa8f2c0abcdc152d)
                        .attr('x', width - margin.right)
                        .attr('fill', 'currentColor')
                        .attr('text-anchor', 'start')
                        .text('Answer')
                    );
                const yAxis = (g) => g
                    .attr("transform", `translate(${margin.left}, 0)`)
                    .call(
                        d3.axisLeft(yScale) // axisLeft() = create left vertical axis (https://www.tutorialsteacher.com/d3js/axes-in-d3)
                            .ticks(15) // ticks() = set no of ticks in this axis (https://observablehq.com/@d3/axis-ticks)
                    )
                    .call(
                        g => g.append("text")
                            .attr("x", -margin.left)
                            .attr("y", 10)
                            .attr("fill", "currentColor")
                            .attr("text-anchor", "start")
                            .text("Frequency")
                    );

                svg.append("g")
                    .attr("fill", "steelblue")
                    .selectAll("rect") // selectAll() = get all DOM element based on selection
                    .data(data) // data() = join array of data to DOM element (https://www.tutorialsteacher.com/d3js/data-binding-in-d3js)
                    .join("rect") // join() = specify what happen to DOM upon data change. has enter(), update() & exit() function to manipulate DOM upon data enter, change or exit (https://observablehq.com/@d3/selection-join)
                        .attr("x", (data, index) => xScale(index))
                        .attr("y", (data) => yScale(data.value))
                        .attr("height", (data) => yScale(0) - yScale(data.value))
                        .attr("width", xScale.bandwidth());

                svg.append("g")
                    .call(xAxis);

                svg.append("g")
                    .call(yAxis);
            }
        </script>
    </body>
</html>
